﻿var statuses = require('../statuses.js');
function diffDependencies(oldDeps, newDeps) {
    oldDeps = oldDeps || [];
    newDeps = newDeps || [];
    
    //index old dependencies
    var oldDepsLookup = {};
    oldDeps.forEach(function (d) {
        if (d.status && d.status == statuses.DEPENDENCY_REMOVED) {
            d.processed = true;
            return; //skip previously removed deps.
        }
        
        if (!d.status) {
            d.status = statuses.DEPENDENCY_ADDED;
        }

        oldDepsLookup[d.appName] = d;
    });
    
    newDeps.forEach(function (nd) {
        if (oldDepsLookup[nd.appName]) { //previous version also had a dependency for that appName
            var od = oldDepsLookup[nd.appName];
            od.processed = true;
            if (od.build == nd.build && od.branch == nd.branch)
                nd.status = statuses.DEPENDENCY_NOT_CHANGED;
            else
                nd.status = statuses.DEPENDENCY_CHANGED;
        }
        else {
            nd.status = statuses.DEPENDENCY_ADDED; //New dependency that didn't exist previously
        }
    });

    oldDeps.forEach(function (d) {
        if (!d.processed) {            
            //clone the dependency and say that it was removed
            var removedDependency = {
                appName: d.appName, 
                build: d.build,
                branch: d.branch, 
                status : statuses.DEPENDENCY_REMOVED
            }
            newDeps.push(removedDependency);
        }
    });
}
module.exports.diffDependencies = diffDependencies;